<?php

/* ====================
Seditio - Website engine
Copyright Neocrome
http://www.neocrome.net

[BEGIN_SED]
File=plugins/sitestats/sitestats.php
Version=121
Updated=2007-june-18
Type=Plugin
Author=Stamatis Kritikos
Description=Displays various site stats on demand
[END_SED]

[BEGIN_SED_EXTPLUGIN]
Code=sitestats
Part=main
File=sitestats
Hooks=header.tags
Tags=header.tpl:{NUMBERS_CATEGORY.categorycodehere}, {NUMBERS_PAGES}, {NUMBERS_TOPICS}, {NUMBERS_POSTS}, {NUMBERS_FILES}, {NUMBERS_DOWNLOADS}
Order=10
[END_SED_EXTPLUGIN]
==================== */

if (!defined('SED_CODE')) { die('Wrong URL.'); }
// empty mask
$plu_empty = $L['None'];
// function to count pages of given category
function sed_get_numbers($c)
{
	global $L, $db_pages, $cfg, $sed_cat, $plu_empty;

	$mtch = $sed_cat[$c]['path'].".";
	$mtchlen = strlen($mtch);
	$catsub = array();
	$catsub[] = $c;

	@reset($sed_cat);
	while (list($i,$x) = each($sed_cat) )
		{
		if (substr($x['path'],0,$mtchlen)==$mtch)
			{
			$catsub[] = $i;
			}
		}

	$sql = sed_sql_query("SELECT COUNT(*) FROM $db_pages WHERE page_state=0	AND page_cat NOT LIKE 'system' AND page_cat IN ('".implode("','", $catsub)."')");
	$res = sed_sql_result($sql,0,"COUNT(*)");
	$res = (empty($res)) ? $plu_empty : $res;

	return($res);
}
// checks if user has not added any categories in the configuration part of this plugin
if (!empty($cfg['plugin']['sitestats']['categories']))
	{
	$cats = explode(',', $cfg['plugin']['sitestats']['categories']);
	foreach($cats as $k => $i)
		{
		$i = trim($i);
		$numbers[$i] = sed_get_numbers($i);
		}
	}
// count pages site wide
$sqlall = sed_sql_query("SELECT COUNT(*) FROM $db_pages WHERE page_state=0 AND page_cat NOT LIKE 'system'");
$resall = sed_sql_result($sqlall,0,"COUNT(*)");
$resall = (empty($resall)) ? $plu_empty : $resall;
// count total downloadable files in pages
$sqlfiles = sed_sql_query("SELECT COUNT(*) FROM $db_pages WHERE page_file=1 AND page_cat NOT LIKE 'system'");
$resfiles = sed_sql_result($sqlfiles,0,"COUNT(*)");
$resfiles = (empty($resfiles)) ? $plu_empty : $resfiles;
// count total topics in forums
$overalltopics = sed_sql_rowcount($db_forum_topics);
// count total posts in forums
$overallposts = sed_sql_rowcount($db_forum_posts);
// count total times all downloadable files have been downloaded
$totaldownloads = sed_sql_query("SELECT SUM(page_filecount) FROM $db_pages");
$totaldownloads = sed_sql_result($totaldownloads,0,"SUM(page_filecount)");

// SHOW OUTPUTS
$t-> assign(array(
	"NUMBERS_PAGES" => $resall,
	"NUMBERS_CATEGORY" => $numbers,
	"NUMBERS_FILES" => $resfiles,
	"NUMBERS_DOWNLOADS" => $totaldownloads,
	"NUMBERS_TOPICS" => $overalltopics,
	"NUMBERS_POSTS" => $overallposts
	));

?>